define(["require", "exports", "tslib", "react", "@uifabric/styling", "@uifabric/utilities"], function (require, exports, tslib_1, React, styling_1, utilities_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    /**
     * Theme provider is a simplified version of Customizer that activates the appropriate theme data
     * for a given scheme name.
     *
     * @param providers - Injected providers for accessing theme data and providing it via a Customizer component.
     */
    exports.ThemeProvider = function (props) {
        var scheme = props.scheme, theme = props.theme, rest = tslib_1.__rest(props, ["scheme", "theme"]);
        // TODO: consider merging implementation with theme-proto, which only stores a reference / scheme name to theme
        //   in context and uses quick global store accessor to trigger change by passing in theme object as child and
        //   triggering re-render. (perf benefits need verification)
        // tslint:disable-next-line:typedef
        var contextTransform = function (context) {
            return styling_1.getThemedContext(context, scheme, theme);
        };
        return React.createElement(utilities_1.Customizer, tslib_1.__assign({}, rest, { contextTransform: contextTransform }));
    };
});
//# sourceMappingURL=ThemeProvider.js.map